
lib_public {

    // sys.l                                     low-level system abstractions
    // by Mark Duchaineau (free but copyrighted, see LibGen/COPYING)
    //
    // 01-11-94: wrote
    // 04-19-94: added pack.l
    // 08-31-94: added tab.l
    // 04-04-95: added mempool.l
    // 06-03-96: put PI def here
    // 04-02-97: moved Qpool here from Terrain/Qter
    // 05-12-97: major update to pack.l
    // 08-19-97: minor reformatting, comments added
    // 10-21-99: added Dio and Com to this archive
    // 09-11-00: first released version

    // external libraries generally needed by various modules and applications
    lib_include "sys/types.h";
    lib_include "stdio.h";
    lib_include "stdlib.h";
    lib_include "math.h" "-lm";
    lib_include "fcntl.h";
    lib_include "errno.h";
    lib_include "sys/time.h";
    lib_include "signal.h";
    lib_include "sys/stat.h";

    // in case no one else has suppied this basic constant...
    #ifndef PI
        #define PI 3.1415926535897931
    #endif

    lib_archive {
        "Mem/mem.l",              // dynamic memory system (based on sbrk())
        "Mempool/mempool.l",      // fairly fast pools of same-sized items
        "Qpool/qpool.l",          // fastest pools of same-sized items
        "Rnd/rnd.l",              // table-based random numbers/hashing
        "Str/str.l",              // string support
        "Pack/pack.l",            // nested string lists with print/parse
        "Timer/timer.l",          // time-keeper objects
        "Sel/sel.l",              // event system (based on select())
        "Fio/fio.l",              // simple file input/output wrappers
        "Sock/sock.l",            // socket support (TCP/IP SOCK_STREAM)
        "Com/com.l",              // shared-memory communications
        "Dio/dio.l",              // direct file i/o
        "Tab/tab.l"               // key-sort trees
    };

};


